//---     
#include "..\UnlimitedParametersEA.mq5"
//---   
#include "InitializeArrays.mqh"
#include "FileFunctions.mqh"
#include "Enums.mqh"
#include "FileFunctions.mqh"
#include "Errors.mqh"
#include "ToString.mqh"
#include "TradeSignals.mqh"
#include "TradeFunctions.mqh"
//+------------------------------------------------------------------+
//|        (int)             |
//+------------------------------------------------------------------+
int CorrectValueBySymbolDigits(int value)
  {
   return(symb.digits==3 || symb.digits==5) ? value*=10 : value;
  }
//+------------------------------------------------------------------+
//|        (double)          |
//+------------------------------------------------------------------+
double CorrectValueBySymbolDigits(double value)
  {
   return(symb.digits==3 || symb.digits==5) ? value*=10 : value;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
bool IsTester()
  {
   return(MQL5InfoInteger(MQL5_TESTER));
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool IsOptimization()
  {
   return(MQL5InfoInteger(MQL5_OPTIMIZATION));
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
bool IsVisualMode()
  {
   return(MQL5InfoInteger(MQL5_VISUAL_MODE));
  }
//+------------------------------------------------------------------+
//|       ,            |
//|                                         |
//+------------------------------------------------------------------+
bool IsRealtime()
  {
   if(!IsTester() && !IsOptimization() && !IsVisualMode())
      return(true);
   else
      return(false);
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool CheckTradingPermission()
  {
//---    
   if(IsRealtime())
     {
      //---    
      if(!TerminalInfoInteger(TERMINAL_CONNECTED))
         return(1);
      //---        
      if(!MQL5InfoInteger(MQL5_TRADE_ALLOWED))
         return(2);
      //---      
      if(!TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
         return(3);
      //---      
      if(!AccountInfoInteger(ACCOUNT_TRADE_ALLOWED))
         return(4);
      //---       
      if(!AccountInfoInteger(ACCOUNT_TRADE_EXPERT))
         return(5);
     }
//---
   return(0);
  }
//+------------------------------------------------------------------+