//---     
#include "..\UnlimitedParametersEA.mq5"
//---   
#include "Auxiliary.mqh"
#include "InitializeArrays.mqh"
#include "Enums.mqh"
#include "Errors.mqh"
#include "ToString.mqh"
#include "TradeSignals.mqh"
#include "TradeFunctions.mqh"
//+------------------------------------------------------------------+
//|      ,   ,        |
//|   ,                           |
//+------------------------------------------------------------------+
string CreateInputParametersFolder()
  {
   long   search_handle       =INVALID_HANDLE;   //   /
   string EA_root_folder      =EXPERT_NAME+"\\"; //   
   string returned_filename   ="";               //    (/)
   string search_path         ="";               //   
   string folder_filter       ="*";              //   (* -   /)
   bool   is_root_folder      =false;            //  /   

//---    
   search_path=folder_filter;
//---       
   search_handle=FileFindFirst(search_path,returned_filename,FILE_COMMON);
//---    ,  
   if(returned_filename==EA_root_folder)
      is_root_folder=true;
//---    
   if(search_handle!=INVALID_HANDLE)
     {
      //---      
      if(!is_root_folder)
        {
         //---        
         while(FileFindNext(search_handle,returned_filename))
           {
            //---   
            if(IsStopped())
               return("");
            //---  ,   
            if(returned_filename==EA_root_folder)
              {
               is_root_folder=true;
               break;
              }
           }
        }
      //---     
      FileFindClose(search_handle);
      //search_handle=INVALID_HANDLE;
     }
//---     
   else
      Print("    ,  "
            " '"+TerminalInfoString(TERMINAL_COMMONDATA_PATH)+"' : ",ErrorDescription(GetLastError()));

//---      
   search_path=EXPERT_NAME+"\\";
//---     
   if(!is_root_folder)
     {
      //---  . 
      if(FolderCreate(EXPERT_NAME,FILE_COMMON))
        {
         //---   ,  
         is_root_folder=true;
         Print("    '..\\"+EXPERT_NAME+"\\'");
        }
      else
        {
         Print("   "
               "  : ",ErrorDescription(GetLastError()));
         return("");
        }
     }
//---    
   if(is_root_folder)
      //---  ,         
      return(search_path+"\\");
//---   ,   
   return("");
  }
//+------------------------------------------------------------------+
//| /   / ()          |
//+------------------------------------------------------------------+
void ReadWriteInputParameters(int symbol_number,string path)
  {
   string file_name=path+InputSymbols[symbol_number]+".ini"; //  
//---
   Print("  '"+file_name+"' ...");
//---      
   int file_handle_read=FileOpen(file_name,FILE_READ|FILE_ANSI|FILE_COMMON);
   
//---  #1:        
   if(file_handle_read!=INVALID_HANDLE && !RewriteParameters)
     {
      Print(" '"+InputSymbols[symbol_number]+".ini' , ...");
      //---   
      ArrayResize(tested_parameters_from_file,TESTED_PARAMETERS_COUNT);
      //---     
      ReadInputParametersValuesFromFile(file_handle_read,tested_parameters_from_file);
      //---    
      if(ArraySize(tested_parameters_from_file)==TESTED_PARAMETERS_COUNT)
        {
         //---     
         InputIndicatorPeriod[symbol_number]    =(int)tested_parameters_from_file[0];
         Print("InputIndicatorPeriod[symbol_number] = "+(string)InputIndicatorPeriod[symbol_number]);
         InputTakeProfit[symbol_number]         =tested_parameters_from_file[1];
         InputStopLoss[symbol_number]           =tested_parameters_from_file[2];
         InputTrailingStop[symbol_number]       =tested_parameters_from_file[3];
         InputReverse[symbol_number]            =(bool)tested_parameters_from_file[4];
         InputLot[symbol_number]                =tested_parameters_from_file[5];
         InputVolumeIncrease[symbol_number]     =tested_parameters_from_file[6];
         InputVolumeIncreaseStep[symbol_number] =tested_parameters_from_file[7];
        }
      //---    
      FileClose(file_handle_read);
      return;
     }
//---  #2:       
   if(file_handle_read==INVALID_HANDLE || RewriteParameters)
     {
      //---     
      FileClose(file_handle_read);
      //---     
      int file_handle_write=FileOpen(file_name,FILE_WRITE|FILE_CSV|FILE_ANSI|FILE_COMMON,"");
      //---   
      if(file_handle_write!=INVALID_HANDLE)
        {
         string delimiter="="; // 
         //---  
         for(int i=0; i<TESTED_PARAMETERS_COUNT; i++)
           {
            FileWrite(file_handle_write,input_parameters_names[i],delimiter,tested_parameters_values[i]);
            Print(input_parameters_names[i],delimiter,tested_parameters_values[i]);
           }
         //---     
         InputIndicatorPeriod[symbol_number]    =(int)tested_parameters_values[0];
         InputTakeProfit[symbol_number]         =tested_parameters_values[1];
         InputStopLoss[symbol_number]           =tested_parameters_values[2];
         InputTrailingStop[symbol_number]       =tested_parameters_values[3];
         InputReverse[symbol_number]            =(bool)tested_parameters_values[4];
         InputLot[symbol_number]                =tested_parameters_values[5];
         InputVolumeIncrease[symbol_number]     =tested_parameters_values[6];
         InputVolumeIncreaseStep[symbol_number] =tested_parameters_values[7];
         //---       
         if(RewriteParameters)
            Print("  '"+InputSymbols[symbol_number]+".ini'    '"+EXPERT_NAME+".ex5'");
         else
            Print("  '"+InputSymbols[symbol_number]+".ini'    '"+EXPERT_NAME+".ex5'");
        }
      //---     
      FileClose(file_handle_write);
     }
  }
//+------------------------------------------------------------------+
//|                  |
//|   : =
//+------------------------------------------------------------------+
bool ReadInputParametersValuesFromFile(int handle,double &array[])
  {
   int    delimiter_position  =0;  //    "="  
   int    strings_count       =0;  //  
   string read_string         =""; //  
   ulong  offset              =0;  //   (  )
//---      
   FileSeek(handle,0,SEEK_SET);
//--- ,          
   while(!FileIsEnding(handle))
     {
      //---    
      if(IsStopped())
         return(false);
      //---    
      while(!FileIsLineEnding(handle))
        {
         //---    
         if(IsStopped())
            return(false);
         //---  
         read_string=FileReadString(handle);
         //---     ("=")   
         delimiter_position=StringFind(read_string,"=",0);
         //---  ,    ("=")   
         read_string=StringSubstr(read_string,delimiter_position+1);
         //---   ,     double,   
         array[strings_count]=StringToDouble(read_string);
         //---     
         offset=FileTell(handle);
         //---    
         if(FileIsLineEnding(handle))
           {
            //---    ,     
            if(!FileIsEnding(handle))
               //---      1     
               offset++;
            //---     
            FileSeek(handle,offset,SEEK_SET);
            //---   
            strings_count++;
            //---      
            break;
           }
        }
      //---    ,     
      if(FileIsEnding(handle))
         break;
     }
//---    
   return(true);
  }
//+------------------------------------------------------------------+
//|    ()                    |
//|     temporary_symbols[]          |
//+------------------------------------------------------------------+
//---          
int ReadSymbolsFromFile(string file_name)
  {
   int strings_count=0; //  
//---        
   int file_handle=FileOpen(file_name,FILE_READ|FILE_ANSI|FILE_COMMON);
//---    
   if(file_handle!=INVALID_HANDLE)
     {
      ulong  offset =0; //      
      string text ="";  //       
      //--- ,               
      while(!FileIsEnding(file_handle) || !IsStopped())
        {
         //---          
         while(!FileIsLineEnding(file_handle) || !IsStopped())
           {
            //---   
            text=FileReadString(file_handle);
            //---   
            offset=FileTell(file_handle);
            //---    ,     
            //         
            if(!FileIsEnding(file_handle))
               offset++;
            //---     
            FileSeek(file_handle,offset,SEEK_SET);
            //---    
            if(text!="")
              {
               //---   
               strings_count++;
               //---    ,
               ArrayResize(temporary_symbols,strings_count);
               //---      
               temporary_symbols[strings_count-1]=text;
              }
            //---    
            break;
           }
         //---       
         if(FileIsEnding(file_handle))
            break;
        }
      //---  
      FileClose(file_handle);
     }
//---     
   return(strings_count);
  }
//+------------------------------------------------------------------+
