//---     
#include "..\UnlimitedParametersEA.mq5"
//---   
#include "Auxiliary.mqh"
#include "FileFunctions.mqh"
#include "Enums.mqh"
#include "Errors.mqh"
#include "ToString.mqh"
#include "TradeSignals.mqh"
#include "TradeFunctions.mqh"
//+------------------------------------------------------------------+
//|    InputSymbol[]                          |
//+------------------------------------------------------------------+
void InitializeInputSymbols()
  {
   int    strings_count=0;    //     
   string checked_symbol="";  //       
//---      "TestedSymbols.txt"
   strings_count=ReadSymbolsFromFile("TestedSymbols.txt");
//---          (  ),     
   if(IsOptimization() || ((IsTester() || IsVisualMode()) && SymbolNumber>0))
     {
      //---  ,      
      for(int s=0; s<strings_count; s++)
        {
         //---          
         if(s==SymbolNumber-1)
           {
            //--- ,      
            if((checked_symbol=GetSymbolByName(temporary_symbols[s]))!="")
              {
               //---   
               SYMBOLS_COUNT=1;
               //---    
               ArrayResize(InputSymbols,SYMBOLS_COUNT);
               //---   
               InputSymbols[0]=checked_symbol;
              }
            //--- 
            return;
           }
        }
     }
//---               
   if((IsTester() || IsVisualMode()) && SymbolNumber==0)
     {
      //---   :  
      if(ParametersReadingMode==FILE)
        {
         //---      
         for(int s=0; s<strings_count; s++)
           {
            //--- ,      
            if((checked_symbol=GetSymbolByName(temporary_symbols[s]))!="")
              {
               //---   
               SYMBOLS_COUNT++;
               //---    
               ArrayResize(InputSymbols,SYMBOLS_COUNT);
               //---   
               InputSymbols[SYMBOLS_COUNT-1]=checked_symbol;
              }
           }
         //--- 
         return;
        }
      //---   :    
      if(ParametersReadingMode==INPUT_PARAMETERS)
        {
         //---   
         SYMBOLS_COUNT=1;
         //---    
         ArrayResize(InputSymbols,SYMBOLS_COUNT);
         //---    
         InputSymbols[0]=Symbol();
         //--- 
         return;
        }
     }
//---      ,     
   if(IsRealtime())
     {
      //---   
      SYMBOLS_COUNT=1;
      //---    
      ArrayResize(InputSymbols,SYMBOLS_COUNT);
      //---   
      InputSymbols[0]=Symbol();
     }
//---
  }
//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
void ResizeInputParametersArrays()
  {
   ArrayResize(InputIndicatorPeriod,SYMBOLS_COUNT);
   ArrayResize(InputTakeProfit,SYMBOLS_COUNT);
   ArrayResize(InputStopLoss,SYMBOLS_COUNT);
   ArrayResize(InputTrailingStop,SYMBOLS_COUNT);
   ArrayResize(InputReverse,SYMBOLS_COUNT);
   ArrayResize(InputLot,SYMBOLS_COUNT);
   ArrayResize(InputVolumeIncrease,SYMBOLS_COUNT);
   ArrayResize(InputVolumeIncreaseStep,SYMBOLS_COUNT);
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void InitializeNewBarArray()
  {
//---   
   ArrayResize(new_bar,SYMBOLS_COUNT);
   ArrayResize(lastbar_time,SYMBOLS_COUNT);
//---  
   ArrayInitialize(new_bar,0);
//---    
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---    
      if(InputSymbols[s]!="")
         //---    
         CheckNewBar(s);
     }
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
void InitializeIndicatorHandlesArrays()
  {
//---    
   ArrayResize(spy_indicator_handles,SYMBOLS_COUNT);
   ArrayResize(signal_indicator_handles,SYMBOLS_COUNT);
//---     
   ArrayInitialize(spy_indicator_handles,INVALID_HANDLE);
   ArrayInitialize(signal_indicator_handles,INVALID_HANDLE);
  }
//+------------------------------------------------------------------+
//|                    |
//+------------------------------------------------------------------+
void ResizeDataArrays()
  {
   ArrayResize(close,SYMBOLS_COUNT);
   ArrayResize(open,SYMBOLS_COUNT);
   ArrayResize(high,SYMBOLS_COUNT);
   ArrayResize(low,SYMBOLS_COUNT);
   ArrayResize(indicator,SYMBOLS_COUNT);
  }
//+------------------------------------------------------------------+
//|                  |
//|                                                    |
//+------------------------------------------------------------------+
void InitializeTestedParametersValues()
  {
   tested_parameters_values[0]=IndicatorPeriod;
   tested_parameters_values[1]=TakeProfit;
   tested_parameters_values[2]=StopLoss;
   tested_parameters_values[3]=TrailingStop;
   tested_parameters_values[4]=Reverse;
   tested_parameters_values[5]=Lot;
   tested_parameters_values[6]=VolumeIncrease;
   tested_parameters_values[7]=VolumeIncreaseStep;
  }
//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
void InitializeWithCurrentValues()
  {
   InputIndicatorPeriod[0]=IndicatorPeriod;
   InputTakeProfit[0]=TakeProfit;
   InputStopLoss[0]=StopLoss;
   InputTrailingStop[0]=TrailingStop;
   InputReverse[0]=Reverse;
   InputLot[0]=Lot;
   InputVolumeIncrease[0]=VolumeIncrease;
   InputVolumeIncreaseStep[0]=VolumeIncreaseStep;
  }
//+-------------------------------------------------------------------+
//|         |
//+-------------------------------------------------------------------+
void InitializeInputParametersArrays()
  {
   string path=""; //       

//---  #2 :
//    -       
   if(RewriteParameters)
     {
      //---     
      InitializeWithCurrentValues();
      //---           
      if((path=CreateInputParametersFolder())!="")
         //--- /   
         ReadWriteInputParameters(0,path);
      //---
      return;
     }
//---  #1 :
//    -     
//    -   
//    -        
   if(IsRealtime() || IsOptimization() || (ParametersReadingMode==INPUT_PARAMETERS && !RewriteParameters))
     {
      //---     
      InitializeWithCurrentValues();
      return;
     }
//---  #3 :
//    -   (,   ,  )    
   if((IsTester() || IsVisualMode()) && !IsOptimization() && SymbolNumber>0)
     {
      //---           
      if((path=CreateInputParametersFolder())!="")
        {
         //---     (     = 1)
         for(int s=0; s<SYMBOLS_COUNT; s++)
            //---      
            ReadWriteInputParameters(s,path);
        }
      return;
     }
//---  #4 :
//    -   (,   ,  )    
   if((IsTester() || IsVisualMode()) && !IsOptimization() && SymbolNumber==0)
     {
      //---     
      //         
      if((path=CreateInputParametersFolder())!="")
        {
         //---    
         for(int s=0; s<SYMBOLS_COUNT; s++)
            //---      
            ReadWriteInputParameters(s,path);
        }
      return;
     }
  }
//+------------------------------------------------------------------+
//|      " "                  |
//+------------------------------------------------------------------+
string GetSymbolByName(string symbol)
  {
   string symbol_name=""; //    
//---    ,   
   if(symbol=="")
      return("");
//---       
   for(int s=0; s<SymbolsTotal(false); s++)
     {
      //---   
      symbol_name=SymbolName(s,false);
      //---      
      if(symbol==symbol_name)
        {
         //---     " "
         SymbolSelect(symbol,true);
         //---   
         return(symbol);
        }
     }
//---    ,   
   Print("C "+symbol+"    !");
   return("");
  }
//+------------------------------------------------------------------+
