//---     
#include "..\UnlimitedParametersEA.mq5"
//---   
#include "Auxiliary.mqh"
#include "InitializeArrays.mqh"
#include "FileFunctions.mqh"
#include "Enums.mqh"
#include "Errors.mqh"
#include "ToString.mqh"
#include "TradeFunctions.mqh"
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
void GetSpyHandles()
  {
//---    
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---     
      if(InputSymbols[s]!="")
        {
         //---     
         if(spy_indicator_handles[s]==INVALID_HANDLE)
           {
            //---   
            spy_indicator_handles[s]=iCustom(InputSymbols[s],_Period,"EventsSpy.ex5",ChartID(),0,CHARTEVENT_TICK);
            //---      
            if(spy_indicator_handles[s]==INVALID_HANDLE)
              { Print("     "+InputSymbols[s]+""); }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void GetIndicatorHandles()
  {
//---    
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---      
      if(InputSymbols[s]!="")
        {
         //---     
         if(signal_indicator_handles[s]==INVALID_HANDLE)
           {
            //---   
            signal_indicator_handles[s]=iMA(InputSymbols[s],_Period,InputIndicatorPeriod[s],0,MODE_SMA,PRICE_CLOSE);
            
            Print(InputSymbols[s]," >> handle: ",signal_indicator_handles[s],"; InputIndicatorPeriod[s]: ",InputIndicatorPeriod[s]);
            
            //---      
            if(signal_indicator_handles[s]==INVALID_HANDLE)
               Print("       "+InputSymbols[s]+"!");
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void GetBarsData(int symbol_number)
  {
//---        
   int NumberOfBars=3;
//---     (... 3 2 1 0)
   ArraySetAsSeries(open[symbol_number].value,true);
   ArraySetAsSeries(high[symbol_number].value,true);
   ArraySetAsSeries(low[symbol_number].value,true);
   ArraySetAsSeries(close[symbol_number].value,true);
//---    ,  
//       
//---    
   if(CopyClose(InputSymbols[symbol_number],_Period,0,NumberOfBars,close[symbol_number].value)<NumberOfBars)
     {
      Print("    ("
            +InputSymbols[symbol_number]+"; "+TimeframeToString(_Period)+")    Close! "
            " ("+IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError())+"");
     }
//---    
   if(CopyOpen(InputSymbols[symbol_number],_Period,0,NumberOfBars,open[symbol_number].value)<NumberOfBars)
     {
      Print("    ("
            +InputSymbols[symbol_number]+"; "+TimeframeToString(_Period)+")    Open! "
            " ("+IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError())+"");
     }
//---    
   if(CopyHigh(InputSymbols[symbol_number],_Period,0,NumberOfBars,high[symbol_number].value)<NumberOfBars)
     {
      Print("    ("
            +InputSymbols[symbol_number]+"; "+TimeframeToString(_Period)+")    High! "
            " ("+IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError())+"");
     }
//---    
   if(CopyLow(InputSymbols[symbol_number],_Period,0,NumberOfBars,low[symbol_number].value)<NumberOfBars)
     {
      Print("    ("
            +InputSymbols[symbol_number]+"; "+TimeframeToString(_Period)+")    Low! "
            " ("+IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError())+"");
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
bool GetDataIndicators(int symbol_number)
  {
//---           
   int NumberOfValues=3;
//---     
   if(signal_indicator_handles[symbol_number]!=INVALID_HANDLE)
     {
      //---     (... 3 2 1 0)
      ArraySetAsSeries(indicator[symbol_number].value,true);
      //---   
      if(CopyBuffer(signal_indicator_handles[symbol_number],0,0,NumberOfValues,indicator[symbol_number].value)<NumberOfValues)
        {
         Print("    ("+
               InputSymbols[symbol_number]+"; "+TimeframeToString(_Period)+")   indicator!  ("+
               IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError())+"");
         return(false);
        }
      return(true);
     }
//---     , ...
   else
     {
      // ...    
      GetIndicatorHandles();
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE GetTradingSignal(int symbol_number)
  {
//---   
   if(!pos.exists)
     {
      //---    :
      if(GetSignal(symbol_number)==ORDER_TYPE_SELL)
        return(ORDER_TYPE_SELL);
      //---    :
      if(GetSignal(symbol_number)==ORDER_TYPE_BUY)
        return(ORDER_TYPE_BUY);
     }
//---   
   if(pos.exists) 
     {
      //---   
      GetPositionProperties(symbol_number,P_TYPE);
      //---    
      GetPositionProperties(symbol_number,P_PRICE_LAST_DEAL);
      
      //---    :
      if(pos.type==POSITION_TYPE_BUY && 
         GetSignal(symbol_number)==ORDER_TYPE_SELL)
         return(ORDER_TYPE_SELL);
      //---
      if(pos.type==POSITION_TYPE_SELL &&
         GetSignal(symbol_number)==ORDER_TYPE_SELL && 
         close[symbol_number].value[1]<pos.last_deal_price-CorrectValueBySymbolDigits(InputVolumeIncreaseStep[symbol_number]*symb.point))
         return(ORDER_TYPE_SELL);
      
      //---    :
      if(pos.type==POSITION_TYPE_SELL &&
         GetSignal(symbol_number)==ORDER_TYPE_BUY)
         return(ORDER_TYPE_BUY);
      //---
      if(pos.type==POSITION_TYPE_BUY &&
         GetSignal(symbol_number)==ORDER_TYPE_BUY && 
         close[symbol_number].value[1]>pos.last_deal_price+CorrectValueBySymbolDigits(InputVolumeIncreaseStep[symbol_number]*symb.point))
         return(ORDER_TYPE_BUY);
     }
//---  
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE GetSignal(int symbol_number)
  {
//---    :
   if(indicator[symbol_number].value[1]<indicator[symbol_number].value[2])
     return(ORDER_TYPE_SELL);
//---    :
   if(indicator[symbol_number].value[1]>indicator[symbol_number].value[2])
     return(ORDER_TYPE_BUY);
//---  
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
