//+------------------------------------------------------------------+
//|                                        UnlimitedParametersEA.mq5 |
//|            Copyright 2013, https://login.mql5.com/ru/users/tol64 |
//|                                  Site, http://tol64.blogspot.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2013, http://tol64.blogspot.com"
#property link        "http://tol64.blogspot.com"
#property description "email: hello.tol64@gmail.com"
#property version     "1.0"
//---  
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME)
//---  / 
#define TESTED_PARAMETERS_COUNT 8
//---    
#include <Trade/Trade.mqh>
//---  
CTrade   trade;
//---   
#include "Include\Enums.mqh"
#include "Include\InitializeArrays.mqh"
#include "Include\Errors.mqh"
#include "Include\FileFunctions.mqh"
#include "Include\TradeSignals.mqh"
#include "Include\TradeFunctions.mqh"
#include "Include\ToString.mqh"
#include "Include\Auxiliary.mqh"
//---   
sinput long                      MagicNumber          =777;      //  
sinput int                       Deviation            =10;       // 
sinput string                    delimeter_00=""; // --------------------------------
sinput int                       SymbolNumber         =1;        //   
sinput bool                      RewriteParameters    =false;    //  
sinput ENUM_INPUTS_READING_MODE  ParametersReadingMode=FILE;     //   
sinput string                    delimeter_01=""; // --------------------------------
input  int                       IndicatorPeriod      =5;        //  
input  double                    TakeProfit           =100;      //  
input  double                    StopLoss             =50;       //  
input  double                    TrailingStop         =10;       //  
input  bool                      Reverse              =true;     //  
input  double                    Lot                  =0.1;      // 
input  double                    VolumeIncrease       =0.1;      //   
input  double                    VolumeIncreaseStep   =10;       //    
//---   .           
int SYMBOLS_COUNT=0;

//---   
string InputSymbols[];            //  
//---
int    InputIndicatorPeriod[];    //  
double InputTakeProfit[];         //   
double InputStopLoss[];           //   
double InputTrailingStop[];       //   
bool   InputReverse[];            //    
double InputLot[];                //  
double InputVolumeIncrease[];     //   
double InputVolumeIncreaseStep[]; //    
//---    -
int spy_indicator_handles[];
//---    
int signal_indicator_handles[];
//---      
struct PriceData
  {
   double            value[];
  };
PriceData open[];      //   
PriceData high[];      //   
PriceData low[];       //   
PriceData close[];     //   
PriceData indicator[]; //   
//---       
struct Datetime
  {
   datetime          time[];
  };
Datetime lastbar_time[];
//---        
datetime new_bar[];
//---        
string input_parameters_names[TESTED_PARAMETERS_COUNT]=
  {
   "IndicatorPeriod",   //  
   "TakeProfit",        //  
   "StopLoss",          //  
   "TrailingStop",      //  
   "Reverse",           //  
   "Lot",               // 
   "VolumeIncrease",    //   
   "VolumeIncreaseStep" //    
  };
//---    
string temporary_symbols[];
//--- ,        ,     
double tested_parameters_from_file[];
//---        
double tested_parameters_values[TESTED_PARAMETERS_COUNT];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
void OnInit()
  {
//---         
   InitializeTestedParametersValues();
//---     
   InitializeInputSymbols();
//---     
   ResizeInputParametersArrays();
//---    
   InitializeIndicatorHandlesArrays();
//---          
   InitializeInputParametersArrays();
//---      "EventsSpy.ex5"
   GetSpyHandles();
//---   
   GetIndicatorHandles();
//---   
   InitializeNewBarArray();
//---      
   ResizeDataArrays();
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---    
   if(reason==REASON_REMOVE)
     {
      //---   
      for(int s=0; s<SYMBOLS_COUNT; s++)
        {
         IndicatorRelease(spy_indicator_handles[s]);
         IndicatorRelease(signal_indicator_handles[s]);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         //  
                  const long &lparam,   //    long
                  const double &dparam, //    double
                  const string &sparam) //    string
  {
//---    
   if(id>=CHARTEVENT_CUSTOM)
     {
      //--- ,   
      if(CheckTradingPermission()>0)
         return;
      //---    ""
      if(lparam==CHARTEVENT_TICK)
        {
         //---      
         CheckSignalsAndTrade();
         return;
        }
     }
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
void CheckSignalsAndTrade()
  {
//---     
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---    
      if(InputSymbols[s]!="")
        {
         //---    ,    
         if(!CheckNewBar(s))
            continue;
         //---    
         else
           {
            //---   .   ,    
            if(!GetDataIndicators(s))
               continue;
            //---                  
            GetBarsData(s);
            //---    
            TradingBlock(s);
            //--- 
            ModifyTrailingStop(s);
           }
        }
     }
  }
//+------------------------------------------------------------------+
