//+------------------------------------------------------------------+
//|                                                    EventsSpy.mq5 |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//+------------------------------------------------------------------+
#define VERSION       "1.00 Build 3 (26 Dec 2010)"
//---
#property copyright   "Copyright 2010, Lizar"
#property link        "https://login.mql5.com/ru/users/Lizar"
#property description " - Control panel MCM."
#property description "           NewBar / NewTick  - "
//---
#property indicator_chart_window
#property indicator_plots 0
//---
//+------------------------------------------------------------------+
//|         . |
//|     .     |
//|      "|"                        |
//+------------------------------------------------------------------+
enum ENUM_CHART_EVENT_SYMBOL
  {
   CHARTEVENT_INIT      =0,          //  "" 
   CHARTEVENT_NO        =0,          //  
   //---
   CHARTEVENT_NEWBAR_M1 =0x00000001, //  " "  1 - 
   CHARTEVENT_NEWBAR_M2 =0x00000002, //  " "  2 - 
   CHARTEVENT_NEWBAR_M3 =0x00000004, //  " "  3 - 
   CHARTEVENT_NEWBAR_M4 =0x00000008, //  " "  4 - 
   //---
   CHARTEVENT_NEWBAR_M5 =0x00000010, //  " "  5 - 
   CHARTEVENT_NEWBAR_M6 =0x00000020, //  " "  6 - 
   CHARTEVENT_NEWBAR_M10=0x00000040, //  " "  10- 
   CHARTEVENT_NEWBAR_M12=0x00000080, //  " "  12- 
   //---
   CHARTEVENT_NEWBAR_M15=0x00000100, //  " "  15- 
   CHARTEVENT_NEWBAR_M20=0x00000200, //  " "  20- 
   CHARTEVENT_NEWBAR_M30=0x00000400, //  " "  30- 
   CHARTEVENT_NEWBAR_H1 =0x00000800, //  " "  1 - 
   //---
   CHARTEVENT_NEWBAR_H2 =0x00001000, //  " "  2 - 
   CHARTEVENT_NEWBAR_H3 =0x00002000, //  " "  3 - 
   CHARTEVENT_NEWBAR_H4 =0x00004000, //  " "  4 - 
   CHARTEVENT_NEWBAR_H6 =0x00008000, //  " "  6 - 
   //---
   CHARTEVENT_NEWBAR_H8 =0x00010000, //  " "  8 - 
   CHARTEVENT_NEWBAR_H12=0x00020000, //  " "  12- 
   CHARTEVENT_NEWBAR_D1 =0x00040000, //  " "   
   CHARTEVENT_NEWBAR_W1 =0x00080000, //  " "   
   //---
   CHARTEVENT_NEWBAR_MN1=0x00100000, //  " "      
   CHARTEVENT_TICK      =0x00200000, //  " "
   //---
   CHARTEVENT_ALL=0xFFFFFFFF         //   
  };
//---
input long                    chart_id;                 //  - 
input ushort                  custom_event_id;          //    
input ENUM_CHART_EVENT_SYMBOL flag_event=CHARTEVENT_NO; // ,   .
//---
MqlDateTime time,prev_time;
//---
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,     //   price[]
                 const int prev_calculated, //     
                 const int begin,           //    
                 const double& price[]      //   
                 )
  {
   double price_current=price[rates_total-1];
//---
   TimeCurrent(time);
//---
   if(prev_calculated==0)
     {
      EventCustom(CHARTEVENT_INIT,price_current);
      prev_time=time;
      return(rates_total);
     }
//---
// New tick
   if((flag_event&CHARTEVENT_TICK)!=0) { EventCustom(CHARTEVENT_TICK,price_current); }
//---
// Check change time
   if(time.min==prev_time.min   && 
      time.hour==prev_time.hour && 
      time.day==prev_time.day   &&
      time.mon==prev_time.mon
      )
     {
      return(rates_total);
     }
//---
// New minute
   if((flag_event&CHARTEVENT_NEWBAR_M1)!=0) { EventCustom(CHARTEVENT_NEWBAR_M1,price_current); }
//---
   if(time.min%2 ==0 && (flag_event&CHARTEVENT_NEWBAR_M2)!=0)  { EventCustom(CHARTEVENT_NEWBAR_M2,price_current); }
   if(time.min%3 ==0 && (flag_event&CHARTEVENT_NEWBAR_M3)!=0)  { EventCustom(CHARTEVENT_NEWBAR_M3,price_current); }
   if(time.min%4 ==0 && (flag_event&CHARTEVENT_NEWBAR_M4)!=0)  { EventCustom(CHARTEVENT_NEWBAR_M4,price_current); }
   if(time.min%5 ==0 && (flag_event&CHARTEVENT_NEWBAR_M5)!=0)  { EventCustom(CHARTEVENT_NEWBAR_M5,price_current); }
   if(time.min%6 ==0 && (flag_event&CHARTEVENT_NEWBAR_M6)!=0)  { EventCustom(CHARTEVENT_NEWBAR_M6,price_current); }
   if(time.min%10==0 && (flag_event&CHARTEVENT_NEWBAR_M10)!=0) { EventCustom(CHARTEVENT_NEWBAR_M10,price_current); }
   if(time.min%12==0 && (flag_event&CHARTEVENT_NEWBAR_M12)!=0) { EventCustom(CHARTEVENT_NEWBAR_M12,price_current); }
   if(time.min%15==0 && (flag_event&CHARTEVENT_NEWBAR_M15)!=0) { EventCustom(CHARTEVENT_NEWBAR_M15,price_current); }
   if(time.min%20==0 && (flag_event&CHARTEVENT_NEWBAR_M20)!=0) { EventCustom(CHARTEVENT_NEWBAR_M20,price_current); }
   if(time.min%30==0 && (flag_event&CHARTEVENT_NEWBAR_M30)!=0) { EventCustom(CHARTEVENT_NEWBAR_M30,price_current); }
//---
   if(time.min!=0) { prev_time=time; return(rates_total); }
//---
// New hour
   if((flag_event&CHARTEVENT_NEWBAR_H1)!=0) { EventCustom(CHARTEVENT_NEWBAR_H1,price_current); }
//---
   if(time.hour%2 ==0 && (flag_event&CHARTEVENT_NEWBAR_H2)!=0)  { EventCustom(CHARTEVENT_NEWBAR_H2,price_current); }
   if(time.hour%3 ==0 && (flag_event&CHARTEVENT_NEWBAR_H3)!=0)  { EventCustom(CHARTEVENT_NEWBAR_H3,price_current); }
   if(time.hour%4 ==0 && (flag_event&CHARTEVENT_NEWBAR_H4)!=0)  { EventCustom(CHARTEVENT_NEWBAR_H4,price_current); }
   if(time.hour%6 ==0 && (flag_event&CHARTEVENT_NEWBAR_H6)!=0)  { EventCustom(CHARTEVENT_NEWBAR_H6,price_current); }
   if(time.hour%8 ==0 && (flag_event&CHARTEVENT_NEWBAR_H8)!=0)  { EventCustom(CHARTEVENT_NEWBAR_H8,price_current); }
   if(time.hour%12==0 && (flag_event&CHARTEVENT_NEWBAR_H12)!=0) { EventCustom(CHARTEVENT_NEWBAR_H12,price_current); }
//---
   if(time.hour!=0) { prev_time=time; return(rates_total); }
//---
// New day
   if((flag_event&CHARTEVENT_NEWBAR_D1)!=0) { EventCustom(CHARTEVENT_NEWBAR_D1,price_current); }
//---
// New week
   if(time.day_of_week==1 && (flag_event&CHARTEVENT_NEWBAR_W1)!=0) { EventCustom(CHARTEVENT_NEWBAR_W1,price_current); }
//---
// New month
   if(time.day==1 && (flag_event&CHARTEVENT_NEWBAR_MN1)!=0) { EventCustom(CHARTEVENT_NEWBAR_MN1,price_current); }
//---
   prev_time=time;
//---
// Return value of prev_calculated for next call
   return(rates_total);
  }
//---
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void EventCustom(ENUM_CHART_EVENT_SYMBOL event,double price)
  {
   EventChartCustom(chart_id,custom_event_id,(long)event,price,_Symbol); return;
  }
//+------------------------------------------------------------------+
